include "ZeroPage.inc"
include "VVram.inc"
include "Chars.inc"

ext VVram_
ext BaseX_, BaseY_, Map_

MapStep equ 8

pSource equ ZW0
pDestination equ ZW1


; ptr<byte> VVramPtr(byte x, byte y);
dseg
VVramPtr_@Param0: public VVramPtr_@Param0
VVramPtr_x:
	defs 1
VVramPtr_@Param1: public VVramPtr_@Param1
VVramPtr_y:
	defs 1
cseg
Table:
defw VVramWidth*0,VVramWidth*1,VVramWidth*2,VVramWidth*3,VVramWidth*4,VVramWidth*5,VVramWidth*6,VVramWidth*7,VVramWidth*8,VVramWidth*9,VVramWidth*10,VVramWidth*11,VVramWidth*12,VVramWidth*13,VVramWidth*14,VVramWidth*15,VVramWidth*16,VVramWidth*17,VVramWidth*18,VVramWidth*19
VVramPtr_: public VVramPtr_
	pha
        lda	VVramPtr_y
        asl a ;*2
        tax
        lda Table,x | clc|adc VVramPtr_x | tay
        lda Table+1,x | adc #0 | tax
        tya | clc|adc #low VVram_ | tay
        txa | adc #high VVram_ | tax
	pla
rts


; void MapToVVram();
zseg
mapOffset:
    defb 0
vvramOffset:
    defb 0
mapByte:
    defb 0
cseg
MapToVVram_: public MapToVVram_
    pha
        lda BaseY_ | sta <pSource+0
        lda #0 | sta <pSource+1
        asl <pSource+0 | rol <pSource+1   ; *2
        asl <pSource+0 | rol <pSource+1   ; *4
        asl <pSource+0 | rol <pSource+1   ; *8 : MapStep
        
        lda <pSource+0 | clc|adc #low Map_ | sta <pSource+0
        lda <pSource+1 | adc #high Map_ | sta <pSource+1

        lda BaseX_
        lsr a | lsr a | lsr a
        clc|adc <pSource+0 | sta <pSource+0
        lda <pSource+1 | adc #0 | sta <pSource+1
        
        lda #1 | sta <mapByte
        lda BaseX_
        and #7
        tax
        do | while ne
            asl <mapByte
            dex
        wend
        ldy #0 | sty <mapOffset

        lda #low VVram_ | sta <pDestination+0
        lda #high VVram_ | sta <pDestination+1

        ldx #VVramHeight
        do
            lda <mapByte
            pha
                lda <mapOffset
                pha
                    ldy #0
                    do
                        sty <vvramOffset

                        ldy <mapOffset
                        lda (<pSource),y
                        and <mapByte
                        if ne
                            lda #Char_Wall
                        else
                            lda #Char_Space
                        endif
                                            _deb: public _deb
                        
                        asl <mapByte
                        if eq
                            iny
                            inc <mapByte
                        endif
                        sty <mapOffset

                        ldy <vvramOffset
                        sta (<pDestination),y
                        iny
                        cpy #VVramWidth
                    while ne | wend
                pla
                clc|adc #MapStep
                sta <mapOffset
            pla
            sta <mapByte
            
            lda <pDestination+0 | clc|adc #VVramWidth | sta <pDestination+0
            lda <pDestination+1 | adc #0 | sta <pDestination+1

            dex
        while ne | wend
    pla
rts
